//+------------------------------------------------------------------+
//|                                           Dynamic trend line.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 3 
#property indicator_color1 Red  
#property indicator_color2 Black 
#property indicator_color3 Black
#property indicator_width1 3
#property indicator_width2 2
#property indicator_width3 2

extern int TimeFrame= 0;
extern int Periodos=5;
extern int Percent =3;
extern bool AlertsMessage = true;
extern bool AlertsSound   = true;
extern bool AlertsEmail   = false;

double DynamicLine []; 
double BUYSignal [];
double SELLSignal [];
double c,cc,d,dd,b,v;
int    tiempo;
  
//+------------------------------------------------------------------

int init ()
{
   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, DynamicLine); 
   SetIndexStyle (1, DRAW_ARROW);
   SetIndexArrow (1,233);
   SetIndexBuffer(1, BUYSignal); 
   SetIndexStyle (2, DRAW_ARROW);
   SetIndexArrow (2,234);
   SetIndexBuffer(2, SELLSignal);
   TimeFrame = MathMax(TimeFrame,Period());
    
switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
      
string short_name="MTF Dynamic trend(" + DoubleToStr(Periodos,0) + ")"+TimeFrameStr;
IndicatorShortName(short_name);

return (0);
}

// +------------------------------------------------------------------

 int start () 
 {  
   int counted_bars=IndicatorCounted()-1000;
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   for (int i = limit; i>=0; i--)
    {
      int y = iBarShift(Symbol(), TimeFrame, Time[i]);
  
// Calculation DynamicLineTrend of maximal period
       
      if (Close [i] < DynamicLine [i+1])
         {
            // Calculate Up trend
            DynamicLine [i] =Close [Highest (NULL, TimeFrame, MODE_CLOSE, Periodos, y+1)]+Percent;
         }
          
      if (Close [i] > DynamicLine [i+1])
         {
            // Calculate Down trend
            DynamicLine [i] =Close [Lowest (NULL, TimeFrame, MODE_CLOSE, Periodos, y+1)]-Percent;
         } 
      
// Check crosses DynamicTrend and Price
      
      if (Close [i] > DynamicLine [i] && Close [i+1] < DynamicLine [i+1]){b=BUYSignal [i] =Low [i]-5;}
      if (Close [i] < DynamicLine [i] && Close [i+1] > DynamicLine [i+1]){v=SELLSignal [i] =High [i]+5;}
      if (i==1 && b > v){Alertar("SELL");}
      if (i==1 && b < v){Alertar("BUY");}
      
    }
return (0);
}

void Alertar(string doalert)
      {
      string msg;
      if (tiempo!=Time[0])
         {
         msg = "DynamicTrend: "+doalert+" "+Symbol()+ " TF "+Period()+ " min at " +   DoubleToStr(Close[0],Digits);     
         if (AlertsMessage) Alert(msg);
         if (AlertsSound)   PlaySound("alert3.wav");
         if (AlertsEmail)   SendMail("Alerta de trading " + TimeToStr(TimeCurrent()),msg);
         tiempo=Time[0];
         }
      }
